#!/bin/sh
repo="/etc/sys_conf"

maxn=10
tmplprefix="iss_"
tmpltrail=".conf"
pattern="${tmplprefix}*${tmpltrail}"
headlink="headiss.conf"
flist=""
topfn=""
topnum=0

next_fn() {
  if [ -z "$flist" ]; then
    printf "${tmplprefix}%03d${tmpltrail}" 0
    return
  fi
  tfn=$topfn
  tfn=${tfn#$tmplprefix}
  topnum=${tfn%$tmpltrail}
  nextnum=$(expr $topnum + 1)
  printf "${tmplprefix}%03d${tmpltrail}" $nextnum
}

update_flist() {
  flist=$(ls $repo/$pattern | sort -r)
  tfn=$(basename $(echo $flist | cut -d " " -f1))
  topfn=$tfn
  tfn=${tfn#$tmplprefix}                            
  topnum=${tfn%$tmpltrail} 
}

check_purge() {
  t=0
  for f in $flist; do
    if [ $t -ge $maxn ]; then
      rm -f $f
    fi
    t=$(expr $t + 1)
  done 
}

check_headlink() {
  [ -z "$flist" ] && return
  linkt=$(readlink $repo/$headlink)  
  [ "$linkt" = "$topfn" ] && return
  echo "make $topfn the new head"
  cd $repo
  rm -f $headlink
  ln -s $topfn $headlink
}

crepo_headfn() {
  echo "$repo/$topfn"
}

crepo_push_file() {
  cmp -s $1 $(crepo_headfn) && return 1
  ! confverify $1 > /dev/null && return 2

  nextffn="$repo/$(next_fn)"
  cp $1 $nextffn
  crepo_maintain
  return 0
}

crepo_pop_file() {
  [ -z "$flist" ] && return
  rm $repo/$topfn
  crepo_maintain
}

crepo_maintain() {
  update_flist
  check_headlink
  check_purge
}

file_valid() {
  confverify $1
}

crepo_validate() {
  update_flist
  [ -z "$flist" ] && return
  for f in $flist; do 
    if ! file_valid $f; then
      rm -f $f  
    fi
  done
  crepo_maintain
}

crepo_init_env() {
  lst=`ls $repo/$pattern 2> /dev/null`
  if [ -z "$lst" ]; then
    dstf="${repo}/iss_000.conf"
    cp /usr/local/bin/iss-default.conf $dstf
    confset $dstf 1.3.6.1.4.1.2076.81.1.1.0 QSW-$(i2ctool get_model)
  fi
  crepo_maintain 
}

crepo_init_env
